/*
   K2, recv-doord.c
   v 0.1.4
*/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <string.h>

#define LOGDIR "/var/adm/doord/"
#define PORT 54242
#define SIZE 2048

int main()
{
   char buf[SIZE];
   char zbuf[1024];
   char pstr[2];
   char uids[5],euids[5];
   char fsys[] = "-FROM_SYS";
   char fuser[] = "-FROM_USER";
   int n,s,ns,len,pty,uid,euid;
   struct sockaddr_in name;
   FILE *logfile;
   
   s = socket(AF_INET, SOCK_STREAM, 0);
   memset(&name,0,sizeof(struct sockaddr_in));
   
   name.sin_family = AF_INET;
   name.sin_port = htons(PORT);
   len = sizeof(struct sockaddr_in);
   
   n = INADDR_ANY;
   memcpy(&name.sin_addr, &n, sizeof(long));
   
   if(bind(s, (struct sockaddr *) &name, len) < 0) {
      perror("bind");
      exit(1);
   }   
   if(listen(s,4) < 0) {
      perror("listen");
      exit(1);
   }

   /* infinate accept loop */      
   for(;;) {
      if((ns = accept(s,(struct sockaddr *) &name, &len)) < 0) {
         perror("accept");
         exit(1);
      }
      
      while((n = recv(ns,buf,sizeof(buf),0)) > 0) {
         memcpy(uids,buf+1,5);
         memcpy(euids,buf+6,5);
         memcpy(pstr,buf+11,2);
         pty = atoi(pstr);
         uid = atoi(uids);
         euid = atoi(euids);
         
         if(buf[0] == 'S')
            snprintf(zbuf,1023,"%s%d%s:%d:%d",LOGDIR,pty,fsys,uid,euid);
         else
            snprintf(zbuf,1023,"%s%d%s:%d:%d",LOGDIR,pty,fuser,uid,euid);
         
         logfile = fopen(zbuf,"ab+");
         fprintf(logfile,"%s",buf+13); fclose(logfile);
         memset(buf,0,n);
      }
      close(ns);
   }
   close(s);
   exit(0);
}
